import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 工作人员分配服务对象基类
 *
 * @export
 * @class HRDistributionServiceBase
 * @extends {EntityServie}
 */
export default class HRDistributionServiceBase extends EntityService {

    /**
     * Creates an instance of  HRDistributionServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  HRDistributionServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof HRDistributionServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='hrdistribution';
        this.APPDEKEY = 'hrdistributionid';
        this.APPDENAME = 'hrdistributions';
        this.APPDETEXT = 'hrdistributionname';
        this.APPNAME = 'pim';
        this.SYSTEMNAME = 'ibizhumanresources';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && context.hrdistribution){
            let res:any = Http.getInstance().get(`/hrposts/${context.hrpost}/hrdistributions/${context.hrdistribution}/select`,isloading);
            
            return res;
        }
        if(context.hremployee && context.hrdistribution){
            let res:any = Http.getInstance().get(`/hremployees/${context.hremployee}/hrdistributions/${context.hrdistribution}/select`,isloading);
            
            return res;
        }
            let res:any = Http.getInstance().get(`/hrdistributions/${context.hrdistribution}/select`,isloading);
            
            return res;
    }

    /**
     * Create接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async Create(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && true){
            let masterData:any = {};
            Object.assign(data,masterData);
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            let tempContext:any = JSON.parse(JSON.stringify(context));
            let res:any = await Http.getInstance().post(`/hrposts/${context.hrpost}/hrdistributions`,data,isloading);
            
            return res;
        }
        if(context.hremployee && true){
            let masterData:any = {};
            Object.assign(data,masterData);
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            let tempContext:any = JSON.parse(JSON.stringify(context));
            let res:any = await Http.getInstance().post(`/hremployees/${context.hremployee}/hrdistributions`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
        if(!data.srffrontuf || data.srffrontuf !== "1"){
            data[this.APPDEKEY] = null;
        }
        if(data.srffrontuf){
            delete data.srffrontuf;
        }
        let tempContext:any = JSON.parse(JSON.stringify(context));
        let res:any = await Http.getInstance().post(`/hrdistributions`,data,isloading);
        
        return res;
    }

    /**
     * Update接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async Update(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && context.hrdistribution){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().put(`/hrposts/${context.hrpost}/hrdistributions/${context.hrdistribution}`,data,isloading);
            
            return res;
        }
        if(context.hremployee && context.hrdistribution){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().put(`/hremployees/${context.hremployee}/hrdistributions/${context.hrdistribution}`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().put(`/hrdistributions/${context.hrdistribution}`,data,isloading);
            
            return res;
    }

    /**
     * Remove接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async Remove(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && context.hrdistribution){
            let res:any = Http.getInstance().delete(`/hrposts/${context.hrpost}/hrdistributions/${context.hrdistribution}`,isloading);
            return res;
        }
        if(context.hremployee && context.hrdistribution){
            let res:any = Http.getInstance().delete(`/hremployees/${context.hremployee}/hrdistributions/${context.hrdistribution}`,isloading);
            return res;
        }
            let res:any = Http.getInstance().delete(`/hrdistributions/${context.hrdistribution}`,isloading);
            return res;
    }

    /**
     * Get接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async Get(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && context.hrdistribution){
            let res:any = await Http.getInstance().get(`/hrposts/${context.hrpost}/hrdistributions/${context.hrdistribution}`,isloading);
            
            return res;
        }
        if(context.hremployee && context.hrdistribution){
            let res:any = await Http.getInstance().get(`/hremployees/${context.hremployee}/hrdistributions/${context.hrdistribution}`,isloading);
            
            return res;
        }
            let res:any = await Http.getInstance().get(`/hrdistributions/${context.hrdistribution}`,isloading);
            
            return res;
    }

    /**
     * GetDraft接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async GetDraft(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && true){
            let res:any = await Http.getInstance().get(`/hrposts/${context.hrpost}/hrdistributions/getdraft`,isloading);
            res.data.hrdistribution = data.hrdistribution;
            
            return res;
        }
        if(context.hremployee && true){
            let res:any = await Http.getInstance().get(`/hremployees/${context.hremployee}/hrdistributions/getdraft`,isloading);
            res.data.hrdistribution = data.hrdistribution;
            
            return res;
        }
        let res:any = await  Http.getInstance().get(`/hrdistributions/getdraft`,isloading);
        res.data.hrdistribution = data.hrdistribution;
        
        return res;
    }

    /**
     * CheckKey接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async CheckKey(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && context.hrdistribution){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hrposts/${context.hrpost}/hrdistributions/${context.hrdistribution}/checkkey`,data,isloading);
            
            return res;
        }
        if(context.hremployee && context.hrdistribution){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hremployees/${context.hremployee}/hrdistributions/${context.hrdistribution}/checkkey`,data,isloading);
            
            return res;
        }
            let res:any = Http.getInstance().post(`/hrdistributions/${context.hrdistribution}/checkkey`,data,isloading);
            return res;
    }

    /**
     * Save接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async Save(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && context.hrdistribution){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hrposts/${context.hrpost}/hrdistributions/${context.hrdistribution}/save`,data,isloading);
            
            return res;
        }
        if(context.hremployee && context.hrdistribution){
            let masterData:any = {};
            Object.assign(data,masterData);
            let res:any = await Http.getInstance().post(`/hremployees/${context.hremployee}/hrdistributions/${context.hrdistribution}/save`,data,isloading);
            
            return res;
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().post(`/hrdistributions/${context.hrdistribution}/save`,data,isloading);
            
            return res;
    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof HRDistributionServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.hrpost && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hrposts/${context.hrpost}/hrdistributions/fetchdefault`,tempData,isloading);
            return res;
        }
        if(context.hremployee && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            let res:any = Http.getInstance().get(`/hremployees/${context.hremployee}/hrdistributions/fetchdefault`,tempData,isloading);
            return res;
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        let res:any = Http.getInstance().get(`/hrdistributions/fetchdefault`,tempData,isloading);
        return res;
    }
}